

//#define _UNICODE

#include <atldef.h>
#include <windows.h>
#include <atlbase.h>
#include <atlapp.h>


CAppModule _Module;


#include <atlwin.h>
#include <atlmisc.h>
#include "CDxWindowImpl.h"


class CDxAppWindow : public CDxWindowImpl<CDxAppWindow>
{
public:

  static LPCTSTR GetWndClassName()
  {
    return _T("CDxAppWindow");
  }



  BEGIN_MSG_MAP(CDxAppWindow)
    CHAIN_MSG_MAP(CDxWindowImpl<CDxAppWindow>)
  END_MSG_MAP()
};



int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, 
                                           int nCmdShow)
{
  CMessageLoop messageLoop;
  CDxAppWindow mainwnd;


  _Module.Init(NULL, hInstance);
  _Module.AddMessageLoop(&messageLoop);

  mainwnd.Create(NULL,CWindow::rcDefault,_T("Main Window"));
  if(mainwnd == NULL)
    return 0;

  mainwnd.ShowWindow(nCmdShow);
  mainwnd.UpdateWindow();

  /*  Switch between full screen and windowed
  //  wait two seconds then go full screen
  Sleep(2000);
  mainwnd.FullScreen();

  //  wait two seconds then go back to windowed
  Sleep(2000);
  mainwnd.Windowed();

  //  Set the client rectangle to be 640 X 480
  mainwnd.ResizeClient(640,480);

  //  Wait two seconds then go fullscreen again
  Sleep(2000);
  mainwnd.FullScreen();

  //  Wait two seconds and then back to the windowed 640 X 480 client area
  Sleep(2000);
  mainwnd.Windowed();
  */

  int nRet = messageLoop.Run();

  _Module.RemoveMessageLoop();
  _Module.Term();

  return nRet;
}
